package com.V10lator.TimeEvent;

import java.io.FileWriter;
import java.io.IOException;

class SaveThread extends Thread
{
  private TimeEvent plugin;
  SaveThread(final TimeEvent plugin)
  {
    this.plugin = plugin;
  }
  
  public void run()
  {
    int ret = save();
    if(ret < 0)
    {
      if(ret == -1)
        plugin.info2log("Can't save (" + ret + ")");
    }
	else
	  plugin.info2log(ret + " Events saved");
  }
  
  short save()
  {
	//Write file to ram
    String out = new String();
    short c = 0;
	for(EventStone stone: plugin.eventStone.values())
	{
	  out = out + 
		    stone.world + "," + 
		    stone.x + "," +
		    stone.y + "," +
			stone.z + "," +
			stone.time + "," +
		    stone.orig + "\n";
	  c++;
	}
	if(!plugin.activeStone.isEmpty())
	{
	  for(EventStone stone: plugin.activeStone)
	  {
		out = out + 
			  stone.world + "," + 
			  stone.x + "," +
			  stone.y + "," +
			  stone.z + "," +
			  stone.time + "," +
			  stone.orig + "\n";
		c++;
	  }
	}
	if(plugin.Init.saveRAM.equals(out))
	  return -2;
	
	try
	{
	  FileWriter writer = new FileWriter(plugin.Init.saveFile);
	  writer.write(out);
	  writer.close();
	}
	catch (IOException e)
	{
	  return -1;
	}
	return c;
  }
}

