package com.V10lator.TimeEvent;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.logging.Logger;
import org.bukkit.plugin.PluginDescriptionFile;
import org.bukkit.plugin.PluginManager;
import org.bukkit.plugin.java.JavaPlugin;
import org.bukkit.Material;
import org.bukkit.Server;
import org.bukkit.block.Block;
import org.bukkit.event.Event;

import com.V10lator.lib24time.lib24time;

public class TimeEvent extends JavaPlugin
{
  private Logger log = Logger.getLogger("Mineraft");
  private final TimeEventBlockListener blockListener = new TimeEventBlockListener(this);
  private final TimeEventCustomListener customListener = new TimeEventCustomListener(this);
  Init Init;
  
  int pid[] = {-1,-1};
  String name = null;
  final HashMap<Block, EventStone> eventStone = new HashMap<Block, EventStone>();
  final ArrayList<EventStone> activeStone = new ArrayList<EventStone>();
  
  public void onEnable()
  {
	int saveIntervall = 15;
	
	Server server = getServer();
	PluginManager pm = server.getPluginManager();
	if(!lib24time.isInitialized())
	{
	  info2log("ERROR: lib24time not ready!");
	  pm.disablePlugin(this);
	  return;
	}
	if(lib24time.getVersion() < 0.7)
	{
	  info2log("ERROR: lib24time >= 0.7 needed (" + lib24time.getVersion() + " found)");
	  pm.disablePlugin(this);
	  return;
	}
	
	pm.registerEvent(Event.Type.SIGN_CHANGE, blockListener, Event.Priority.Normal, this);
	pm.registerEvent(Event.Type.BLOCK_BREAK, blockListener, Event.Priority.Normal, this);
	pm.registerEvent(Event.Type.BLOCK_PHYSICS, blockListener, Event.Priority.Normal, this);
	pm.registerEvent(Event.Type.CUSTOM_EVENT, customListener, Event.Priority.Normal, this);
	
	PluginDescriptionFile pdfFile = this.getDescription();
    name = pdfFile.getName();
    
    Init = new Init(this, server, name);
    int ret = Init.initialize((short)0);
    if(ret < 0)
    {
      info2log("Can't load save file (Step 1, " + ret + ")");
      pm.disablePlugin(this);
	  return;
    }
	ret = Init.initialize((short)1);
	if(ret < 0)
	{
	  info2log("Can't load save file (Step 2, " + ret + ")");
	  pm.disablePlugin(this);
	  return;
	}
	info2log(ret + " Events loaded");
	
	pid[0] = server.getScheduler().scheduleSyncRepeatingTask(this, new EventThread(this), 0L, 1L);
	pid[1] = server.getScheduler().scheduleSyncRepeatingTask(this, new SaveThread(this), 60 * saveIntervall * 10, 60 * saveIntervall * 10);
    
    info2log("v" + pdfFile.getVersion() + " enabled");
  }
  
  public void onDisable()
  {
	getServer().getScheduler().cancelTask(pid[0]);
	getServer().getScheduler().cancelTask(pid[1]);
	
	if(!activeStone.isEmpty())
	{
	  Iterator<EventStone> stonei = activeStone.iterator();
	  while(stonei.hasNext())
	  {
		EventStone stone = stonei.next();
		Block block = getServer().getWorld(stone.world).getBlockAt(stone.x, stone.y, stone.z);
		
		block.setTypeIdAndData(Material.SIGN_POST.getId(), stone.orig, true);
		stonei.remove();
		eventStone.put(block, stone);
	  }
	}
	
	SaveThread SaveThread = new SaveThread(this);
	int ret = SaveThread.save();
	if(ret < 0)
    {
      if(ret == -2)
        info2log("No new save needed, skipping..");
      else
    	info2log("Can't save (" + ret + ")");
    }
	else
	  info2log(ret + " Events saved");
	
	info2log("disabled");
  }
  
  public void info2log(String text)
  {
    log.info("[" + name + "] " + text + ".");
  }
}
