package com.V10lator.TimeEvent;

import java.util.Iterator;

import org.bukkit.block.Block;
import org.bukkit.Material;
import org.bukkit.inventory.ItemStack;
import org.bukkit.entity.Player;
import org.bukkit.event.block.BlockBreakEvent;
import org.bukkit.event.block.BlockListener;
import org.bukkit.event.block.SignChangeEvent;
import org.bukkit.event.block.BlockPhysicsEvent;
import org.bukkit.ChatColor;

import com.V10lator.lib24time.lib24time;

public class TimeEventBlockListener extends BlockListener
{
  private TimeEvent plugin;
  public TimeEventBlockListener(final TimeEvent plugin)
  {
	this.plugin = plugin;
  }
  
  public void onBlockPhysics(BlockPhysicsEvent event)
  {
	Block block = event.getBlock();
	for(EventStone sign: plugin.activeStone)
	{
	  if(block.getWorld().getName().equals(sign.world) &&
		 block.getX() == sign.x &&
		 block.getY() == sign.y &&
	     block.getZ() == sign.z)
	  {
		event.setCancelled(true);
		break;
	  }
	}
  }
  
  public void onSignChange(SignChangeEvent event)
  {
	Block block = event.getBlock();
	Player player = event.getPlayer();
	String[] lines = event.getLines();
	EventStone stone = new EventStone(block);
	
	if(!lines[1].equalsIgnoreCase("[TimeEvent]"))
	  return;
	
	if(!player.hasPermission("timeevent.build"))
	{
	  player.sendMessage(ChatColor.RED+"You are not allowed to do that!");
	  block.setType(Material.AIR);
	  player.getInventory().addItem(new ItemStack(Material.SIGN, 1));
	  return;
	}
	
	if(block.getType() == Material.WALL_SIGN)
	{
	  player.sendMessage(ChatColor.RED + "Wall signs are currently not supported by TimeEvent");
	  block.setType(Material.AIR);
	  player.getInventory().addItem(new ItemStack(Material.SIGN, 1));
	  return;
	}
	if(lines[2].isEmpty())
	{
      player.sendMessage(ChatColor.RED + "A TimeEvent needs a Time!");
	  return;
	}
	Material under = block.getWorld().getBlockAt(block.getX(), block.getY() - 1, block.getZ()).getType();
	if(under == Material.GLASS ||
	   under == Material.ICE ||
	   under == Material.LEAVES ||
	   under == Material.SIGN_POST ||
	   under == Material.WALL_SIGN)
	{
      player.sendMessage(ChatColor.RED + "WARNING: " + ChatColor.YELLOW + "A TimeEvent is a redstone circurit");
      player.sendMessage(ChatColor.YELLOW + "           So it can't be build on " + ChatColor.RED + under.name());
	  block.setType(Material.AIR);
	  player.getInventory().addItem(new ItemStack(Material.SIGN, 1));
	  return;
	}
	
	long foo = lib24time.time2code(lines[2]);
	if(foo < 0)
	{
	  player.sendMessage(ChatColor.RED + lines[2] + "is no valid Time! (lib24time: " + foo + ")");
	  return;
	}

	stone.world = block.getWorld().getName();
    stone.x = block.getX();
    stone.y = block.getY();
    stone.z = block.getZ();
    stone.time = lib24time.code2time(foo);
	this.plugin.eventStone.put(block, stone);
	player.sendMessage(ChatColor.YELLOW + "TimeEvent " + ChatColor.GREEN + "created");
  }
  
  public void onBlockBreak(BlockBreakEvent event)
  {
	Block block = event.getBlock();
	for(EventStone sign: plugin.eventStone.values())
	{
	  if(block.getWorld().getName().equals(sign.world) &&
	  block.getX() == sign.x &&
	  block.getY() == sign.y &&
	  block.getZ() == sign.z)
	  {
		Player player = event.getPlayer();
	    if(!player.hasPermission("timeevent.build"))
	    {
	      player.sendMessage(ChatColor.RED+"You are not allowed to do that!");
	      event.setCancelled(true);
	      return;
	    }
	    plugin.eventStone.remove(block);
	    player.sendMessage(ChatColor.YELLOW + "TimeEvent " + ChatColor.GREEN + "destroyed");
		return;
	  }
	}
	if(plugin.activeStone.isEmpty())
	  return;
	Iterator<EventStone> signi = plugin.activeStone.iterator();
	while(signi.hasNext())
	{
	  EventStone sign = signi.next();
	  if(block.getWorld().getName().equals(sign.world) &&
	  block.getX() == sign.x &&
	  block.getY() == sign.y &&
	  block.getZ() == sign.z)
	  {
		Player player = event.getPlayer();
	    if(!player.hasPermission("timeevent.build"))
	    {
	      player.sendMessage(ChatColor.RED+"You are not allowed to do that!");
	      event.setCancelled(true);
	      return;
	    }
	    plugin.eventStone.remove(block);
	    event.setCancelled(true);
	    block.setType(Material.AIR);
	    block.getWorld().dropItemNaturally(block.getLocation(), new ItemStack(Material.SIGN, 1));
	    player.sendMessage(ChatColor.YELLOW + "TimeEvent " + ChatColor.GREEN + "destroyed");
		break;
	  }
	}
  }
}
