package com.V10lator.TimeEvent;

import org.bukkit.ChatColor;
import org.bukkit.Material;
import org.bukkit.World;
import org.bukkit.block.Block;
import org.bukkit.block.Sign;
import org.bukkit.event.CustomEventListener;
import org.bukkit.event.Event;
import org.bukkit.event.Listener;

import com.V10lator.lib24time.lib24time;
import com.V10lator.lib24time.event.TimeChangeEvent;

class TimeEventCustomListener extends CustomEventListener implements Listener
{
  final TimeEvent plugin;
  
  TimeEventCustomListener(TimeEvent plugin)
  {
	this.plugin = plugin;
  }
  
  public void onCustomEvent(Event eve)
  {
	if(!(eve instanceof TimeChangeEvent))
	  return;
	TimeChangeEvent event = (TimeChangeEvent)eve;
	World world = event.getWorld();
	String worldName = world.getName();
	String now = event.getTime();
	
	for(EventStone stone: plugin.eventStone.values())
	{
	  Block block = world.getBlockAt(stone.x, stone.y, stone.z);
	  if(stone.world.equals(worldName))
	  {
		if(stone.time.equals(now))
	    {
		  block.setType(Material.REDSTONE_TORCH_ON);
		  stone.active = 16;
		  plugin.activeStone.add(stone);
		  plugin.eventStone.remove(block);
	    }
	    else
	    {
		  //Update sign
		  if(block.getType() == Material.SIGN_POST)
		  {
		    Sign schuidl = ((Sign)block.getState());

		    String time = lib24time.countdown(world, stone.time);
		        
		    schuidl.setLine(0, ChatColor.YELLOW + "Time" + ChatColor.GREEN + "Event");
		    schuidl.setLine(1, "");
		    schuidl.setLine(2, ChatColor.BLUE + "Time left:");
		    schuidl.setLine(3, ChatColor.BLUE + time.split(":")[0] + "h " + time.split(":")[1] + "m");
		    schuidl.update();
		  }
		  else
		  {
		    plugin.info2log("No sign at " + stone.x + "," + stone.y + "," + stone.z);
		    plugin.eventStone.remove(block);
		    plugin.info2log("Removed from list");
		  }
	    }
	  }
	}
  }
}
